/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Patrick Boenzli
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD

#include "single_player_world.h"

#include "state.h"
#include "class_list.h"

#include "load_param.h"
#include "fast_factory.h"
#include "factory.h"

#include "world_entity.h"
#include "npcs/npc_test1.h"


using namespace std;

//! This creates a Factory to fabricate a SinglePlayerWorld
CREATE_FACTORY(SinglePlayerWorld, CL_SINGLE_PLAYER_WORLD);



SinglePlayerWorld::SinglePlayerWorld(const TiXmlElement* root)
  : GameWorld(root)
{
  this->setClassID(CL_SINGLE_PLAYER_WORLD, "SinglePlayerSinglePlayerWorld");
  this->setName("SinglePlayerWorld uninitialized");

  this->loadParams(root);
}


/**
 *  remove the SinglePlayerWorld from memory
 *
 *  delete everything explicitly, that isn't contained in the parenting tree!
 *  things contained in the tree are deleted automaticaly
 */
SinglePlayerWorld::~SinglePlayerWorld ()
{
  PRINTF(3)("SinglePlayerWorld::~SinglePlayerWorld() - deleting current world\n");
}


/**
 * loads the parameters of a SinglePlayerWorld from an XML-element
 * @param root the XML-element to load from
 */
void SinglePlayerWorld::loadParams(const TiXmlElement* root)
{
  static_cast<GameWorld*>(this)->loadParams(root);

  PRINTF(4)("Creating a SinglePlayerWorld\n");
}




// ErrorMessage SinglePlayerWorld::load()
// {
//   static_cast<GameWorld*>(this)->load();
//
//   /* the the single player specific stuff here */
//
//   /* some static world entities */
//   for(int i = 0; i < 100; i++)
//   {
//     WorldEntity* tmp = new NPCTest1();
//     char npcChar[10];
//     sprintf (npcChar, "NPC_%d", i);
//     tmp->setName(npcChar);
//     tmp->setAbsCoor(((float)rand()/RAND_MAX) * 5000, 50/*+ (float)rand()/RAND_MAX*20*/, ((float)rand()/RAND_MAX -.5) *30);
//     this->spawn(tmp);
//   }
// }

